//+------------------------------------------------------------------+
//|              market_increase_order_ecn_80_800_v8_datetime_v3.mq4 |
//|                                                                  |
//|                                                  http://www..com |
//+------------------------------------------------------------------+


#property copyright ""
#include <stdlib.mqh>
#include <WinUser32.mqh>

//-----------------------------------------------------------------------------+
// External Variables



extern double InitialLots            =  0.01;
extern double StopLoss               =  50.0;
extern double TakeProfit             =  0.0;
extern double Trailing               =  5.0;
extern double MinimumProfit          =  10.0;
extern int    Slippage               =   3;
extern int    OpenDistance           =   2;
extern int    OppositeDistance       =  40;
extern int    MagicNumber            = 80800812013; 
extern int    SleepTime              =  10;
extern int    CloseMarketOnFriday    =  22;
extern int    MaxRetries             =  12;


//-----------------------------------------------------------------------------+
// Global Variables

double Spread,StopLevel,FreezeLevel;
double BuyTrigger,SellTrigger,TickValue,TotalOrderProfit;
double  pips2dbl,OpenPrice,BuyStopLoss,BuyTakeProfit,SellStopLoss,SellTakeProfit;
int OTCurrentTick, OTLastTick,TotalOrders;
int BuyTicket,SellTicket,ErrorCode;
int  pips2points,Digits.pips,Retries; 
bool BuyAllowed = true,SellAllowed = true;
//-----------------------------------------------------------------------------+
 int init ()
   {
    if (Digits == 5 || Digits == 3)
       {    
        pips2dbl = Point*10; pips2points = 10; Digits.pips = 1; 
       }
    else 
       {   
        pips2dbl = Point; pips2points =  1; Digits.pips = 0;   
       }
           
      BuyTrigger = Ask + OpenDistance * pips2dbl;
      SellTrigger = Bid - OpenDistance * pips2dbl;
      
      Spread = MarketInfo(Symbol(),MODE_SPREAD);
           
      StopLevel = MarketInfo(Symbol(),MODE_STOPLEVEL)*Point;
            
      FreezeLevel =MarketInfo(Symbol(),MODE_FREEZELEVEL);
      
      TickValue = MarketInfo(Symbol(),MODE_TICKVALUE);
                               
 return(0);   
   }
 
  //+---------------------------------------------------------------------------+
 int start()
   {//0 
   Comment(" Trade Profit is: ",TotalOrderProfit);
             	 		 
  OTLastTick = OTCurrentTick;                      
  OTCurrentTick = OrdersTotal();                  
    if(OTCurrentTick == 0 && OTLastTick > 0)
      {
      BuyTrigger = Ask + OpenDistance * pips2dbl;
      SellTrigger = Bid - OpenDistance * pips2dbl;
      }                                     
    if(OTCurrentTick > 0)OpenOppositeOrder();                                                               
    if(OTCurrentTick > 0)Trail();    
                                
    if(OTCurrentTick == 0)
      {
       BuyAllowed  = true;
       SellAllowed = true; 
 
  //+----------------------------------------------------------------------------+ 
                                                                                                                                                                                                                                                                                                                                                                         
  	 //Buy Order Condition to Open
  	  
   if(Ask > BuyTrigger && BuyAllowed)
     {//5
     while(BuyTicket<=0)
     {	
	  	 RefreshRates();	  		       
       BuyTicket = OrderSend(Symbol(),OP_BUY,InitialLots,Ask,Slippage*pips2points,0,0,"Initial Buy Order",MagicNumber,0,Green);
       if(Retries<=MaxRetries)Retries++;
       else break;
       }                
       if(BuyTicket > -1)     
        {//6
         BuyAllowed = false;SellAllowed = true; 
          Print(" Initial Buy Order Placed - BuyTicket: ",BuyTicket," Open Buy Price: ",DoubleToStr(OrderOpenPrice(),Digits)," Spread: ",DoubleToStr(Spread,Digits));                                                                                                
        }//6
     else
        {//7
          ErrorCode = GetLastError();
          string ErrDesc = ErrorDescription(ErrorCode); 
                 
          string ErrAlert = StringConcatenate(" Initial Buy Order Failed: ",ErrorCode, ": ",ErrDesc);
          Alert(ErrAlert);
         
          string ErrLog = StringConcatenate(" Initial Buy Order Failed -  Ask: ",DoubleToStr(Ask,Digits)," Open Buy Price: ",DoubleToStr(OrderOpenPrice(),Digits)," Spread: ",DoubleToStr(Spread,Digits)," Lots: ",InitialLots," Ticket: " ,BuyTicket," Stop Level: ",StopLevel," Freeze Level: ",FreezeLevel);        
          Print(ErrLog);
         }//7 
    return(0);
     }//5
     
  //-----------------------------------------------------------------------------+	  
  // Sell Order Condition to Open
           
   if(Bid < SellTrigger && SellAllowed)                      
      {//8 
      while(SellTicket<=0)
      {                                
	  	  RefreshRates();					 		
	     SellTicket = OrderSend(Symbol(),OP_SELL,InitialLots,Bid,Slippage*pips2points,0,0,"Initial Sell Order",MagicNumber,0,Red);
	     if(Retries<=MaxRetries)Retries++;
	     else break;
	     }	  
	     if(SellTicket > -1)
 		   {//9
 		     BuyAllowed = true;SellAllowed = false; 
 		     Print(" Initial Sell order Placed: ", SellTicket," Open Sell Price: ",DoubleToStr(OrderOpenPrice(),Digits)," Spread: ",DoubleToStr(Spread,Digits));                                                                             
         }//9
      else
         {//10
           ErrorCode = GetLastError();
           ErrDesc =ErrorDescription(ErrorCode);
                   
           ErrAlert = StringConcatenate(" Initial Sell Order Failed: ",ErrorCode, ": ",ErrDesc);
           Alert(ErrAlert);
         
          ErrLog = StringConcatenate(" Initial Sell Order Failed -  Bid: ",DoubleToStr(Bid,Digits)," Open Sell Price: ",DoubleToStr(OrderOpenPrice(),Digits)," Spread: ",DoubleToStr(Spread,Digits)," Lots: " , InitialLots," Ticket: " ,SellTicket," Stop Level: ",StopLevel," Freeze Level: ", FreezeLevel);
          Print(ErrLog);
         }//10          
      }//8               
   }//
  return(0);
  }//0
  			                       
  //+------------------------------------------------------------------+
        
 void Trail()
    {//
       double TrailingStop = StopLevel + Trailing;          
       double BuyTrailing =  Bid - (TrailingStop * pips2dbl);
       double SellTrailing = Ask + (TrailingStop * pips2dbl);
                       
       for(int OrderCounter = OrdersTotal()-1; OrderCounter >= 0; OrderCounter--)                     
       {//1
          if(!OrderSelect(OrderCounter,SELECT_BY_POS))continue;
          if(OrderType()==OP_BUY && OrderSymbol()== Symbol()&& OrderMagicNumber()== MagicNumber)            
          {//2 
             RefreshRates();           
             if(OrderStopLoss() < (Bid - TrailingStop * pips2dbl-Point) && (Bid - OrderOpenPrice()) >= (MinimumProfit * pips2dbl))  
              {//3               
                if(!OrderModify(OrderTicket(),OrderOpenPrice(),BuyTrailing, OrderTakeProfit(),0,CLR_NONE))
                 {//4
                   ErrorCode = GetLastError();                   
                   string ErrDesc = ErrorDescription(ErrorCode);
                            
                   string ErrAlert = StringConcatenate(" Buy Trailing Stop Failed: ",ErrorCode, ": ",ErrDesc);
                   Alert(ErrAlert);
                  
                   string ErrLog = StringConcatenate(" Buy Trailing Stop Failed -  Bid: ",DoubleToStr(Bid,Digits)," Spread: ",DoubleToStr(Spread,Digits)," Ticket: " , OrderTicket()," Buy Trailing: ",DoubleToStr(BuyTrailing,Digits)," Stop Loss: ",DoubleToStr(BuyStopLoss,Digits)," Stop Level: ",StopLevel," Freeze Level: ",FreezeLevel);
                   Print(ErrLog);
                  }//4               
              }//3
          }//2          
          if(OrderType()==OP_SELL)             
          {//5
             RefreshRates();
             if(OrderStopLoss() > (Ask + TrailingStop * pips2dbl)+Point|| OrderStopLoss()< Point && (OrderOpenPrice() - Ask) >= (MinimumProfit * pips2dbl))                       
              {//6                  
                if(!OrderModify(OrderTicket(),OrderOpenPrice(),SellTrailing,OrderTakeProfit(),0,CLR_NONE))
                 {//7
                   ErrorCode = GetLastError();
                   ErrDesc =ErrorDescription(ErrorCode);
                           
                   ErrAlert = StringConcatenate(" Sell Trailing Stop Failed: ",ErrorCode,": ",ErrDesc);
                   Alert(ErrAlert);
                  
                   ErrLog = StringConcatenate(" Sell Trailing Stop Failed -  Ask: ",DoubleToStr(Ask,Digits)," Spread: ",DoubleToStr(Spread,Digits)," Ticket: ",OrderTicket()," Sell Trailing: ",DoubleToStr(SellTrailing,Digits)," Stop Loss: ",DoubleToStr(SellStopLoss,Digits)," Stop Level: ",StopLevel," Freeze Level: ",FreezeLevel);
                   Print(ErrLog);
                 }//7                                                     
             }//6
          }//5
       }//1
    }//0             
//+------------------------------------------------------------------+
 
  void OpenOppositeOrder()
    {//0     
     int Op; 
         
     for(int Counter = OrdersTotal()-1; Counter >= 0; Counter--)     
      {//1
      if(!OrderSelect(Counter,SELECT_BY_POS,MODE_TRADES))continue;          
         {//2
         if(OrderSymbol() == Symbol()&& OrderMagicNumber() == MagicNumber)           
            {//3
             Op = OrderType();            
             if (Op == OP_BUY && (OrderOpenPrice() - OrderClosePrice())/Point >= OppositeDistance && SellAllowed)
               {//4
               while(SellTicket<=0) 
               {                            
                 RefreshRates();                             
                 SellTicket = OrderSend(Symbol(), OP_SELL, InitialLots, Bid, Slippage*pips2points, 0,0, "Sell Opposite Order", MagicNumber, 0, Red);
                 if(Retries<=MaxRetries)Retries++;
                 else break;
                  }
                  if(SellTicket > -1)                   
                   {//5                     
                     BuyAllowed=true;SellAllowed=false;
                     CloseBuy();                                                                                
                     Print(" Opposite Sell Order Placed: ","Order Ticket: ",SellTicket," Spread: ",DoubleToStr(Spread,Digits)," Open Price: ",DoubleToStr(OrderOpenPrice(),Digits));                 
                  return;
                   }//5                 
               else
                   {//6                  
                    ErrorCode = GetLastError();
                    string ErrDesc =ErrorDescription(ErrorCode);
                   
                    string ErrAlert = StringConcatenate(" Open Opposite Order - Opposite Sell Failed: ",ErrorCode, ": ",ErrDesc);
                    Alert(ErrAlert);
         
                    string ErrLog = StringConcatenate(" Open Opposite Order - Bid: ",DoubleToStr(Bid,Digits)," Open Price: ",DoubleToStr(OrderOpenPrice(),Digits)," Ticket: ",SellTicket," Spread: ",DoubleToStr(Spread,Digits)," Lots: ",InitialLots," Stop Level: ",StopLevel," Freeze Level: " ,FreezeLevel);
                    Print(ErrLog);                    
                   }//6
               }//4                      
             if(Op == OP_SELL && (OrderClosePrice() - OrderOpenPrice())/Point >= OppositeDistance && BuyAllowed)              
                {//7
                 while(BuyTicket<=0)
                 {                                                
	               RefreshRates();	          	        
                  BuyTicket = OrderSend(Symbol(), OP_BUY, InitialLots, Ask, Slippage*pips2points, 0,0, "Buy Opposite Order", MagicNumber, 0, Green);
                  if(Retries<=MaxRetries)Retries++;
                  else break;
                  } 
                  if(BuyTicket > -1)
                   {//8                     
                     BuyAllowed=false;SellAllowed=true;
                     CloseSell();                                                                            
                     Print(" Opposite Buy Order Placed: ",BuyTicket," Spread: ",DoubleToStr(Spread,Digits)," Open Price: ",DoubleToStr(OrderOpenPrice(),Digits));                                   
                return;
                  }//8
               else
                  {//9                     
                    ErrorCode = GetLastError();
                    ErrDesc =ErrorDescription(ErrorCode);
                  
                    ErrAlert = StringConcatenate(" Open Opposite Order - Opposite Buy Failed: ",ErrorCode, ": ",ErrDesc);
                    Alert(ErrAlert);
         
                    ErrLog = StringConcatenate(" Open Opposite Order -  Ask: ",DoubleToStr(Ask,Digits)," Open Price: ",DoubleToStr(OrderOpenPrice(),Digits)," Ticket: ",BuyTicket," Spread: ",DoubleToStr(Spread,Digits)," Lots: ",InitialLots," Stop Level: ",StopLevel," Freeze Level: ",FreezeLevel);
                    Print(ErrLog);
                  }//9   
               }//7
            }//3
         }//2   
      }//1          
   }//0
                            
 //-----------------------------------------------------------------------------+	  
  	
    void CloseSell()
              {//0
               int OrdType;
               int GLError;
               
                for(int OrderPos = OrdersTotal()-1; OrderPos >= 0; OrderPos--)       
                if(OrderSelect(OrderPos, SELECT_BY_POS, MODE_TRADES)
                   && OrderMagicNumber()== MagicNumber 
                   && OrderSymbol()== Symbol())                                       
                   {//1
                   OrdType = OrderType();
                   if(OrdType==OP_SELL)
                      {//2
                      	 RefreshRates();           
                     if(!OrderClose(OrderTicket(), OrderLots(), OrderClosePrice(),Slippage*pips2points, Yellow))                
                        {//3
                           ErrorCode = GetLastError();
                           string ErrDesc =ErrorDescription(ErrorCode);
                  
                           string ErrAlert = StringConcatenate(" Error Closing Order ",ErrorCode,": ",ErrDesc);
                           Alert(ErrAlert);
         
                           string ErrLog = StringConcatenate(" Close Price: ",DoubleToStr(OrderClosePrice(),Digits)," Ticket: ",OrderTicket()," Lots: ", InitialLots," Stop Level: ",StopLevel," Freeze Level: ",FreezeLevel);
                           Print(ErrLog);
                        }//3
                      }//2               
                    }//1                         
                 }//0 
 //-----------------------------------------------------------------------------+ 
     void CloseBuy()
              {//0
               int OrdType;
               int GLError;
               
                for(int OrderPos = OrdersTotal()-1; OrderPos >= 0; OrderPos--)       
                if(OrderSelect(OrderPos, SELECT_BY_POS, MODE_TRADES)
                   && OrderMagicNumber()== MagicNumber 
                   && OrderSymbol()== Symbol())                                       
                   {//1
                   OrdType = OrderType();
                   if(OrdType==OP_BUY)
                      {//2
                      	 RefreshRates();           
                     if(!OrderClose(OrderTicket(), OrderLots(), OrderClosePrice(),Slippage*pips2points, Yellow))                
                        {//3
                           ErrorCode = GetLastError();
                           string ErrDesc =ErrorDescription(ErrorCode);
                  
                           string ErrAlert = StringConcatenate(" Error Closing Order ",ErrorCode,": ",ErrDesc);
                           Alert(ErrAlert);
         
                           string ErrLog = StringConcatenate(" Close Price: ",DoubleToStr(OrderClosePrice(),Digits)," Ticket: ",OrderTicket()," Lots: ", InitialLots," Stop Level: ",StopLevel," Freeze Level: ",FreezeLevel);
                           Print(ErrLog);
                        }//3
                      }//2               
                    }//1                         
                 }//0 
  //-----------------------------------------------------------------------------+                            	